<template>
<div class="ReportTable">
    <h2 v-if='title'>{{title}}</h2>
    <table v-if='tableData'>
        <thead>
            <tr>
                <th v-text='tableData.label || ""'/>
                <th v-for='(date, i) in tableData.days' :key='i'>{{$f.dateformat(date, 'd mmm')}}</th>
            </tr>
        </thead>
        <tbody>
            <tr v-for='(row, j) in tableData.values' :key='j'>
                <td>{{labels[tableData.rows[j]] || tableData.rows[j]}}</td>
                <td v-for='(value, k) in row' :key='k'>
                    {{$f.amount(value, null, '\u2009')}}
                </td>
            </tr>
        </tbody>
    </table>
</div>
</template>

<script lang="ts">
import {Vue, Options, Prop} from '@/vue';
import {MetricLabels} from '@/types/metrics';

interface TableData {
    label:string;
    head?:string[];
    rows?:string[];
    days?:Date[];
    values:any[][];
}

@Options<ReportTable>({
    beforeMount() {
        // this.getUserCounters();
        // this.updateDisallowed().then(() => '');
        this.tableData = this.googleReport ? this.parseGoogleReport(this.googleReport) :
            (this.yandexReport ? this.parseYandexReport(this.yandexReport) : null);
    },
}) export default class ReportTable extends Vue {
    @Prop({default: null}) yandexReport!:null;
    @Prop({default: null}) googleReport!:null;
    @Prop({default: ''}) title!:string;

    labels = {...MetricLabels};
    tableData:TableData|null = null;

    parseYandexReport(report:any):TableData {
        const days = report.time_intervals.map((t:string[]) => {
            const date = new Date(t[1]);
            date.setMinutes(date.getMinutes() + date.getTimezoneOffset());
            return date;
        });
        const rows = report.query.metrics.map((m:any) => m);
        const values = [...report.data[0].metrics];

        return {
            label: 'Yandex',
            head: undefined,
            days,
            rows,
            values,
        };
    }

    parseGoogleReport(report:any):TableData {

        const reDate = /(\d{4})(\d{2})(\d{2})/gi;
        const head:(Date|null)[] = Array(report.data.rowCount);
        const columns = Array(report.data.rowCount);
        report.data.rows.forEach((r:any, k:number) => {
            const d = reDate.exec(r.dimensions[0]);
            const date = !d ? null : new Date(`${d[1]}-${d[2]}-${d[3]}`);
            if (date) date.setMinutes(date.getTimezoneOffset());
            head[k] = date;
            reDate.lastIndex = 0;

            columns[k] = r.metrics[0].values.map((v:string) => parseInt(v, 10));
        });

        const metrics = report.columnHeader.metricHeader.metricHeaderEntries;

        function transMatrix(A:any[][]) {
            const m = A.length;
            const n = A[0].length;
            const AT:any[][] = [];
            for (var i = 0; i < n; i += 1) {
                AT[i] = [];
                for (var j = 0; j < m; j += 1) AT[i][j] = A[j][i];
            }
            return AT;
        }

        return {
            label: 'Google',
            values: transMatrix(columns),
            rows: metrics.map((m:any) => m.name),
            days: head as Date[],
        };
    }
}
</script>

<style lang="less">
@import '@/style/vars';
@keyframes tableAppear {
    from {
        transform: translateY(20px);
        opacity: 0;
    }
    to {
        transform: translateY(0px);
        opacity: 1;
    }
}
.ReportTable {
    animation: tableAppear .5s ease;
    border: 1px solid @border-color;
    border-radius: 4px;

    & > table {
        table-layout: fixed;
        width: 100%;
        border: inherit;
        border-collapse: collapse;
        border-radius: inherit;
        overflow: hidden;

        td, th {
            border: 1px solid whitesmoke;
            padding: .5625rem .625rem .5rem;
        }

        th {
            &:first-of-type {
                border-radius: 4px 0 0;
                background-color: @royalblue;
                color: white;
            }
        }

        td {
            &:nth-child(n + 2) {
                color: rgb(53,53,53);
                text-align: right;
                font-size: 87.5%;
                // font-family: monospace;
                white-space: nowrap;
            }
        }

        th, td:first-of-type {
            background-color: @aliceblue;
            border-color: white;
            font-weight: 600;
            font-size: 87.5%;
        }
    }
}
</style>